## devicexlib 0.8.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.21 FATAL_ERROR)

project(dmr
    VERSION 0.3
    DESCRIPTION "Fortran Library for OpenMP Device Memory Routines"
    LANGUAGES Fortran)

###########################################################
# Build Type
###########################################################
set(default_build_type "Release")
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    message(STATUS "Setting build type to '${default_build_type}' as none was specified.")
    set(CMAKE_BUILD_TYPE "${default_build_type}"
        CACHE STRING "Choose the type of build." FORCE)
    # Set the possible values of build type for cmake-gui
    set_property(CACHE CMAKE_BUILD_TYPE
        PROPERTY
            STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

###########################################################
# Build helpers
###########################################################
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

############################################################
# Compiler vendor specific options and bug checks
############################################################
if(CMAKE_Fortran_COMPILER_ID MATCHES "NVHPC")
    include(NVFortranCompiler)
elseif(CMAKE_Fortran_COMPILER_ID MATCHES "GNU")
    include(GNUFortranCompiler)
elseif(CMAKE_Fortran_COMPILER_ID MATCHES "IntelLLVM")
    include(IntelOneAPIFortranCompiler)
elseif(CMAKE_Fortran_COMPILER_ID MATCHES "XL")
    include(XLFortranCompiler)
 elseif(CMAKE_Fortran_COMPILER_ID MATCHES "Cray")
    include(CrayFortranCompiler)
endif()

###########################################################
# OpenMP
###########################################################
find_package(OpenMP REQUIRED)

###########################################################
# Build options
###########################################################
include(CMakeDependentOption)
option(DMR_ENABLE_REAL_128
    "enable support for 128 bits Real and Complex" OFF)
option(DMR_ENABLE_F2008
    "enable support for Fortran 2008 syntax" OFF)
option(DMR_ENABLE_OMP5.1
    "enable OpenMP 5.1 specifications syntax" ON)
option(DMR_ENABLE_TESTS
    "enable unit tests" OFF)

if (NOT CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_Fortran_MODULE_DIRECTORY "${CMAKE_INSTALL_PREFIX}/mod")
endif()

###########################################################
# Dependencies
###########################################################
# Compiler dependencies
if(DMR_ENABLE_REAL_128 STREQUAL "ON")
    if(NOT(CMAKE_Fortran_COMPILER_ID STREQUAL "IntelLLVM"))
        message(FATAL_ERROR "128 bits reals are supported only by Intel LLVM Compiler")
    endif()
endif()

if(DMR_ENABLE_OMP5.1 STREQUAL "ON")
    if(NOT(CMAKE_Fortran_COMPILER_ID STREQUAL "IntelLLVM"))
        message(FATAL_ERROR "OpenMP 5.1 Specifications syntax is supported only by Intel LLVM Compiler")
    endif()
endif()

if(DMR_ENABLE_F2008 STREQUAL "ON")
    if(NOT(CMAKE_Fortran_COMPILER_ID STREQUAL "IntelLLVM"))
        message(FATAL_ERROR "Fortran 2008 syntax is supported only by Intel LLVM Compiler")
    endif()
endif()

###########################################################
# Check if src is present and if not, if sources can be generated
###########################################################
if((EXISTS ${PROJECT_SOURCE_DIR}/src/lib))
   message(NOTICE "dmr sources are available in src directory of the project root directory: nothing has been generated from src_generator")
   # Add source directory
   add_subdirectory(${PROJECT_SOURCE_DIR}/src/lib)
elseif(EXISTS ${CMAKE_CURRENT_BINARY_DIR}/src/lib)
   message(NOTICE "dmr sources are available in src directory of the CMake build directory: nothing has been generated from src_generator")
   # Add source directory
   add_subdirectory(${CMAKE_CURRENT_BINARY_DIR}/src/lib)
else()
   message(NOTICE "dmr sources not found: trying to generate files from src_generator")
   find_package (Python3 COMPONENTS Interpreter Development)
   if(Python3_FOUND)
      file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/src/lib)
      file(COPY_FILE ${CMAKE_CURRENT_SOURCE_DIR}/cmake/CMakeLists.src ${CMAKE_CURRENT_BINARY_DIR}/src/lib/CMakeLists.txt)
      execute_process(COMMAND ${Python3_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/src_generator/generate_library.py ${CMAKE_CURRENT_BINARY_DIR}/src/lib WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/src_generator)
      message(NOTICE "dmr sources generation completed")
      # Add source directory
      add_subdirectory(${CMAKE_CURRENT_BINARY_DIR}/src/lib ${CMAKE_BINARY_DIR}/src/lib)
   else()
      message(FATAL_ERROR "Python3 executable cannot be found: dmr sources cannot be generated")
   endif()
endif()

if(DMR_ENABLE_TESTS STREQUAL "ON")
   if(EXISTS ${PROJECT_SOURCE_DIR}/src/tests)
      message(NOTICE "dmr tests are available in tests directory of the project root directory: nothing has been generated from src_generator")
      # Add test directory
      add_subdirectory(${PROJECT_SOURCE_DIR}/src/tests)
   elseif(EXISTS ${CMAKE_CURRENT_BINARY_DIR}/src/tests)
      message(NOTICE "dmr tests are available in tests directory of the CMake build directory: nothing has been generated from src_generator")
      # Add test directory
      add_subdirectory(${CMAKE_CURRENT_BINARY_DIR}/src/tests)
   else()
      message(NOTICE "dmr tests not found: trying to generate files from src_generator")
      find_package (Python3 COMPONENTS Interpreter Development)
      if(Python3_FOUND)
         file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/src/tests)
         file(COPY_FILE ${CMAKE_CURRENT_SOURCE_DIR}/cmake/CMakeLists.tests ${CMAKE_CURRENT_BINARY_DIR}/src/tests/CMakeLists.txt)
         execute_process(COMMAND ${Python3_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/src_generator/generate_tests.py ${CMAKE_CURRENT_BINARY_DIR}/src/tests WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/src_generator)
         message(NOTICE "dmr tests generation completed")
         # Add test directory
         add_subdirectory(${CMAKE_CURRENT_BINARY_DIR}/src/tests)
      else()
         message(FATAL_ERROR "Python3 executable cannot be found: dmr tests cannot be generated")
      endif()
   endif()
endif()

=== Makefile ===
#
# Copyright (C) 2021, MaX CoE
# Distributed under the MIT License
# (license terms are at http://opensource.org/licenses/MIT).
#
#===============================
# deviceXlib package
#===============================
#
-include make.inc
MAKE=make

#
# manual
#
default:
	@echo
	@echo  "  *** deviceXlib *** "
	@echo
	@echo  "  to configure, type:  ./configure [<options>]"
	@echo  "  to compile,   type:  make <target>"
	@echo
	@echo  "  Possible <target>'s are: "
	@echo
	@echo  "     core               builds the library"
	@echo  "     all                core"
	@echo  "     test               all the executables testing the library"
	@echo  "     deps               update fortran90 dependencies"
	@echo  "     gen                generate Fortran sources"
	@echo  "     clean              remove executables and objects"
	@echo  "     distclean          revert distribution to the original status"
	@echo

#
# MAIN target
#
core: libextlibs libsrc
all: core

deps:
	if test -x ./config/makedeps.sh ; then ./config/makedeps.sh ; fi
gen:
	if test -d src_generator ; then ( cd src_generator ; $(MAKE) ) ; fi

#
# INSTALL target
#
install: all
	mkdir -p $(PREFIX)/lib ; \
		for x in `find src/* -name *.a -type f` ; do \
		cp -v $$x $(PREFIX)/lib/ ; done
	mkdir -p $(PREFIX)/include ; \
		for x in `find include/* -name *.h -type f` ; do \
		cp -v $$x $(PREFIX)/include/ ; done
	mkdir -p $(PREFIX)/include ; \
		for x in `find src/* -name "*.mod*" -type f` ; do \
		cp -v $$x $(PREFIX)/include/ ; done
	mkdir -p $(PREFIX)/include ; \
		for x in `find src/* -name "*.smod*" -type f` ; do \
		cp -v $$x $(PREFIX)/include/ ; done
	mkdir -p $(PREFIX)/bin ; \
		for x in `find src/* -name *.x -type f` ; do \
		cp -v $$x $(PREFIX)/bin/ ; done
	@echo -e '\ndeviceXlib installed in $(PREFIX)\n'

#
# LIBS and MODULES
#
libextlibs:
	if test -d extlibs ; then \
	( cd extlibs ; $(MAKE) ) ; fi

libsrc: libextlibs
	if test -d src/ ; then \
	( cd src/ ; $(MAKE) ) ; fi

test:
	if test -d tests/ ; then \
	( cd tests/ ; ./run.sh -a ) ; fi

clean:
	if test -d extlibs ;   then ( cd extlibs;   $(MAKE) clean ) ; fi
	if test -d src ;       then ( cd src;       $(MAKE) clean ) ; fi
	- /bin/rm -rf *.dat *.mod
	- /bin/rm -rf ./bin/*x

distclean: clean
	if test -d extlibs ;   then ( cd extlibs;   $(MAKE) distclean ) ; fi
	if test -d tests ;     then ( cd tests;   ./run.sh -c ) ; fi
	- /bin/rm -rf make.inc config.log ./config/configure.msg \
		./config/config.log ./config/config.status \
		./config/*.lineno \
		./include/configure.h ./include/fft_defs.h \
	        ./include/c_defs.h    ./include/f_defs.h\
		*/dum1 */dum2

=== src/Makefile ===
#
#===============================
# deviceXlib package
#===============================
#
-include ../make.inc

DIR=src
LIBOBJS_LOC= $(LIBOBJS)

OBJS= \
devxlib.o \
devxlib_async.o \
devxlib_auxfunc.o \
devxlib_auxfunc_addscal.o \
devxlib_auxfunc_conjg.o \
devxlib_auxfunc_mat_upd.o \
devxlib_auxfunc_vec_upd.o \
devxlib_buffer.o \
devxlib_buffers.o \
devxlib_cublas.o \
devxlib_environment.o \
devxlib_linalg.o \
devxlib_linalg_axpy.o \
devxlib_linalg_dot.o \
devxlib_linalg_gemm.o \
devxlib_linalg_gemv.o \
devxlib_malloc.o \
devxlib_malloc_alloc.o \
devxlib_malloc_allocated.o \
devxlib_malloc_free.o \
devxlib_mapping.o \
devxlib_mapping_map.o \
devxlib_mapping_mapped.o \
devxlib_mapping_unmap.o \
devxlib_memcpy.o \
devxlib_memcpy_d2d.o \
devxlib_memcpy_d2h.o \
devxlib_memcpy_h2d.o \
devxlib_memcpy_h2h.o \
devxlib_memset.o \
devxlib_memset_device.o \
devxlib_memset_host.o \
devxlib_missing.o \
devxlib_mklgpu.o \
devxlib_rocblas.o \
devxlib_pinned.o \
mod_blas95.o \
mod_cublas.o \
mod_cublas_core.o \
mod_rocblas.o \
mod_tester_fbuff.o \
nvtx_wrapper.o \
roctx_wrapper.o \
prof_tools.o 

#
# main targets
#
all: libdevXlib.a tests

tests: test_malloc.x test_mapping.x test_memcpy.x test_memcpy_async.x \
       test_buffer.x test_pinned.x test_linalg.x  test_memset.x

test_malloc.x: test_malloc.o $(OBJS)
	$(LD) $(LDFLAGS) -o $@ test_malloc.o \
	       $(OBJS) $(LIBOBJS_LOC) $(LIBS)
	- ( cd ../bin ; ln -sf ../src/$@ . )

test_mapping.x: test_mapping.o $(OBJS)
	$(LD) $(LDFLAGS) -o $@ test_mapping.o \
	       $(OBJS) $(LIBOBJS_LOC) $(LIBS)
	- ( cd ../bin ; ln -sf ../src/$@ . )

test_memcpy.x: test_memcpy.o $(OBJS)
	$(LD) $(LDFLAGS) -o $@ test_memcpy.o \
	       $(OBJS) $(LIBOBJS_LOC) $(LIBS)
	- ( cd ../bin ; ln -sf ../src/$@ . )

test_memset.x: test_memset.o $(OBJS)
	$(LD) $(LDFLAGS) -o $@ test_memset.o \
	       $(OBJS) $(LIBOBJS_LOC) $(LIBS)
	- ( cd ../bin ; ln -sf ../src/$@ . )

test_memcpy_async.x: test_memcpy_async.o $(OBJS)
	$(LD) $(LDFLAGS) -o $@ test_memcpy_async.o \
	       $(OBJS) $(LIBOBJS_LOC) $(LIBS)
	- ( cd ../bin ; ln -sf ../src/$@ . )

test_linalg.x: test_linalg.o $(OBJS)
	$(LD) $(LDFLAGS) -o $@ test_linalg.o \
	       $(OBJS) $(LIBOBJS_LOC) $(LIBS)
	- ( cd ../bin ; ln -sf ../src/$@ . )

test_buffer.x: test_buffer.o $(OBJS)
	$(LD) $(LDFLAGS) -o $@ test_buffer.o \
	       $(OBJS) $(LIBOBJS_LOC) $(LIBS)
	- ( cd ../bin ; ln -sf ../src/$@ . )

test_pinned.x: test_pinned.o $(OBJS)
	$(LD) $(LDFLAGS) -o $@ test_pinned.o \
	       $(OBJS) $(LIBOBJS_LOC) $(LIBS)
	- ( cd ../bin ; ln -sf ../src/$@ . )

libdevXlib.a : $(OBJS)
	$(AR) $(ARFLAGS) $@ $?
	$(RANLIB) $@

# clean
clean:
	 - /bin/rm -rf *.o *.a *core *.F90 work.pc work.pcl *.mod *.x *.modmic *.i *.s
	 - /bin/rm -rf *_tmp.f90 *.smod

distclean:   clean

# dependencies
include make.depend
include make.depend_aux

=== src_generator/Makefile ===
#
#===============================
# deviceXlib package
#===============================
#
-include ../make.inc

DIR=src_gener

#
# main targets
#
all: memcpy auxfunc buffers mapping malloc memset

memcpy auxfunc buffers mapping malloc memset:
	if [ -x generate_$@.py ] ; then ./generate_$@.py ; \
	   mv *.f90 ../src ; fi

# clean
clean:
	 - /bin/rm -rf *.f90 *.F __*__
distclean:   clean

# dependencies
include make.depend

=== TESTING/MATGEN/Makefile ===
include ../../make.inc

#######################################################################
#  This is the makefile to create a library of the test matrix
#  generators used in LAPACK.  The files are organized as follows:
#
#     SCATGEN  -- Auxiliary routines called from both REAL and COMPLEX
#     DZATGEN  -- Auxiliary routines called from both DOUBLE PRECISION
#                 and COMPLEX*16
#     SMATGEN  -- Single precision real matrix generation routines
#     CMATGEN  -- Single precision complex matrix generation routines
#     DMATGEN  -- Double precision real matrix generation routines
#     ZMATGEN  -- Double precision complex matrix generation routines
#
#  The library can be set up to include routines for any combination
#  of the four precisions.  To create or add to the library, enter make
#  followed by one or more of the precisions desired.  Some examples:
#       make single
#       make single complex
#       make single double complex complex16
#  Alternatively, the command
#       make
#  without any arguments creates a library of all four precisions.
#  The library is called
#       tmglib.a
#  and is created at the LAPACK directory level.
#
#  To remove the object files after the library is created, enter
#       make clean
#  On some systems, you can force the source files to be recompiled by
#  entering (for example)
#       make single FRC=FRC
#
#######################################################################
 
SCATGEN = slatm1.o slaran.o slarnd.o

SMATGEN = slatms.o slatme.o slatmr.o slatmt.o \
   slagge.o slagsy.o slakf2.o slarge.o slaror.o slarot.o slatm2.o \
   slatm3.o slatm5.o slatm6.o slatm7.o slahilb.o

CMATGEN = clatms.o clatme.o clatmr.o clatmt.o \
   clagge.o claghe.o clagsy.o clakf2.o clarge.o claror.o clarot.o \
   clatm1.o clarnd.o clatm2.o clatm3.o clatm5.o clatm6.o clahilb.o

DZATGEN = dlatm1.o dlaran.o dlarnd.o

DMATGEN = dlatms.o dlatme.o dlatmr.o dlatmt.o \
   dlagge.o dlagsy.o dlakf2.o dlarge.o dlaror.o dlarot.o dlatm2.o \
   dlatm3.o dlatm5.o dlatm6.o dlatm7.o dlahilb.o

ZMATGEN = zlatms.o zlatme.o zlatmr.o zlatmt.o \
   zlagge.o zlaghe.o zlagsy.o zlakf2.o zlarge.o zlaror.o zlarot.o \
   zlatm1.o zlarnd.o zlatm2.o zlatm3.o zlatm5.o zlatm6.o zlahilb.o

all:	../../$(TMGLIB)

ALLOBJ=$(SMATGEN) $(CMATGEN) $(SCATGEN) $(DMATGEN) $(ZMATGEN)	\
	$(DZATGEN)

../../$(TMGLIB): $(SMATGEN) $(CMATGEN) $(SCATGEN) $(DMATGEN)	\
		$(ZMATGEN) $(DZATGEN)
	$(ARCH) $(ARCHFLAGS) $@ $(ALLOBJ)
	$(RANLIB) $@

single: $(SMATGEN) $(SCATGEN)
	$(ARCH) $(ARCHFLAGS) ../../$(TMGLIB) $(SMATGEN) $(SCATGEN)
	$(RANLIB) ../../$(TMGLIB)

complex: $(CMATGEN) $(SCATGEN)
	$(ARCH) $(ARCHFLAGS) ../../$(TMGLIB) $(CMATGEN) $(SCATGEN)
	$(RANLIB) ../../$(TMGLIB)

double: $(DMATGEN) $(DZATGEN)
	$(ARCH) $(ARCHFLAGS) ../../$(TMGLIB) $(DMATGEN) $(DZATGEN)
	$(RANLIB) ../../$(TMGLIB)

complex16: $(ZMATGEN) $(DZATGEN)
	$(ARCH) $(ARCHFLAGS) ../../$(TMGLIB) $(ZMATGEN) $(DZATGEN)
	$(RANLIB) ../../$(TMGLIB)

$(SCATGEN): $(FRC)
$(SMATGEN): $(FRC)
$(CMATGEN): $(FRC)
$(DZATGEN): $(FRC)
$(DMATGEN): $(FRC)
$(ZMATGEN): $(FRC)
 
FRC:
	@FRC=$(FRC)

clean: ; \
        rm -f *.o

.f.o: ; $(FORTRAN) $(OPTS) -c $< -o $@

slaran.o: slaran.f ; $(FORTRAN) $(NOOPT) -c $<
dlaran.o: dlaran.f ; $(FORTRAN) $(NOOPT) -c $<

=== extlibs/lapack/Makefile ===
#
#===============================
# deviceXlib package
#===============================
#
-include ../../make.inc

LIBNAME=lapack.a
PACKAGE=lapack-3.2
TARBALL=../archive/$(PACKAGE).tar.gz

#
# redefinitions
#
INSTALL_DIR=$(TOPDIR)/extlibs/lapack/tmp
#AUXFLAGS= --prefix=$(INSTALL_DIR)

#
# MAIN target
#
all: package-ready-stamp

uncompress-stamp:
	gunzip < $(TARBALL) | ../../config/missing --run tar xf -
	test -d $(INSTALL_DIR) || mkdir $(INSTALL_DIR)
	touch uncompress-stamp

configure-stamp: uncompress-stamp
	if test -d $(PACKAGE) ; then ( cd $(PACKAGE);  \
		if test -e ./make.inc ; then rm ./make.inc ; fi ; \
	        if test -e ../../../install/make_lapack.inc ; then \
	           cp ../../../install/make_lapack.inc ./make.inc ; \
	        fi ; \
	        if test -e ../../../install/Makefile_lapack ; then \
	           cp ../../../install/Makefile_lapack \
	           ./SRC/Makefile ; fi ) ; \
	fi
	touch configure-stamp
#	if test ./install ; then ( cd ./install ;  \
#	        ./configure_blas $(AUXFLAGS)  \
#	        FC=$(F90) \
#	        F77=$(F77) \
#	        FFLAGS="$(FFLAGS)" \
#	        FCFLAGS="$(F90FLAGS)" \
#	        INSTALL_DIR="$(INSTALL_DIR)" ); \
#	fi
	
package-ready-stamp: uncompress-stamp configure-stamp
	if test -d $(PACKAGE) ; then \
	( cd $(PACKAGE);  $(MAKE) lapacklib ) ; fi
	#
	if test -d ./lib      ; then rm -rf ./lib      ; fi
	mkdir ./lib ;
	mv $(PACKAGE)/*.a ./lib ;
	#
	touch package-ready-stamp

#
# cleaning
#
clean:
	if test -d $(PACKAGE) ; then ( cd $(PACKAGE);  $(MAKE) clean ) ; fi
	- rm -rf ./lib package-ready-stamp configure-stamp 

distclean: clean
	if test -d $(PACKAGE) ; then ( rm -rf $(PACKAGE) ) ; fi 
	- rm uncompress-stamp package-ready-stamp
	- rm ../install/make_lapack.inc
	- rm -rf $(INSTALL_DIR)

=== src/lib/CMakeLists.txt ===
set(SRC_dmr
    # Submodules
    dmr_device_memcpy.F90
    dmr_target_alloc.F90
    dmr_target_free.F90
    dmr_target_init.F90
    dmr_target_is_present.F90
    dmr_target_memcpy.F90
    dmr_target_memcpy_rect.F90
    # Modules
    dmr_environment.F90
    dmr.F90)

if(DMR_ENABLE_OMP5.1 STREQUAL "ON")
    set(SRC_dmr
        ${SRC_dmr}
        dmr_target_associate_ptr.F90
        dmr_target_disassociate_ptr.F90
        dmr_get_mapped_ptr.F90)
endif()

set_source_files_properties(${SRC_dmr}
    PROPERTIES LANGUAGE Fortran)

set_source_files_properties(${SRC_dmr}
    PROPERTIES Fortran_PREPROCESS ON)

set_source_files_properties(${SRC_dmr}
    PROPERTIES CMAKE_Fortran_FORMAT FREE)

add_library(dmr ${SRC_dmr})
add_library(dmr_obj OBJECT ${SRC_dmr})

set(dmrTargets
    dmr
    dmr_obj)

target_link_libraries(dmr
    PRIVATE
        compilerCustomConfigc)

foreach(TARGET ${dmrTargets})
    if(DMR_ENABLE_REAL_128 STREQUAL "ON")
       target_compile_definitions(${TARGET}
          PRIVATE
             "_real128")
    endif()
    if(DMR_ENABLE_OMP5.1 STREQUAL "ON")
       target_compile_definitions(${TARGET}
          PRIVATE
             "_OpenMP_5_1")
    endif()
    if(DMR_ENABLE_F2008 STREQUAL "ON")
       target_compile_definitions(${TARGET}
          PRIVATE
             "_F2008")
    endif()
    # Linking for OpenMP host
    target_link_libraries(${TARGET}
       INTERFACE
        	 OpenMP::OpenMP_Fortran)
endforeach(TARGET)

install(
    TARGETS ${dmrTargets}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

=== src/tests/CMakeLists.txt ===
set(SRC_TEST_ALLOC test_dmr_target_alloc.F90)
set(SRC_TEST_FREE test_dmr_target_free.F90)
set(SRC_TEST_IS_PRESENT test_dmr_target_is_present.F90)

set_source_files_properties(
    ${SRC_TEST_ALLOC}
    ${SRC_TEST_FREE}
    ${SRC_TEST_IS_PRESENT}
    PROPERTIES LANGUAGE Fortran)

set_source_files_properties(
    ${SRC_TEST_ALLOC}
    ${SRC_TEST_FREE}
    ${SRC_TEST_IS_PRESENT}
    PROPERTIES Fortran_PREPROCESS ON)

set_source_files_properties(
    ${SRC_TEST_ALLOC}
    ${SRC_TEST_FREE}
    ${SRC_TEST_IS_PRESENT}
    PROPERTIES CMAKE_Fortran_FORMAT FREE)

add_executable(test_dmr_alloc ${SRC_TEST_ALLOC})
add_executable(test_dmr_free ${SRC_TEST_FREE})
add_executable(test_dmr_is_present ${SRC_TEST_IS_PRESENT})

set(testTargets
    test_dmr_alloc
    test_dmr_free
    test_dmr_is_present)

set_target_properties(test_dmr_alloc
    PROPERTIES OUTPUT_NAME "test_dmr_alloc.x")
set_target_properties(test_dmr_free
    PROPERTIES OUTPUT_NAME "test_dmr_free.x")
set_target_properties(test_dmr_is_present
    PROPERTIES OUTPUT_NAME "test_dmr_is_present.x")

foreach(TARGET ${testTargets})
    target_link_libraries(${TARGET}
        PRIVATE
            dmr
            compilerCustomConfigc)
    target_include_directories(${TARGET}
        PRIVATE
            "${CMAKE_CURRENT_BINARY_DIR}/../../../src/lib")
endforeach(TARGET)

foreach(TARGET ${testTargets})
    if(DMR_ENABLE_REAL_128 STREQUAL "ON")
       target_compile_definitions(${TARGET}
          PRIVATE
             "_real128")
    endif()
    if(DMR_ENABLE_OMP5.1 STREQUAL "ON")
       target_compile_definitions(${TARGET}
          PRIVATE
             "_OpenMP_5_1")
    endif()
    if(DMR_ENABLE_F2008 STREQUAL "ON")
       target_compile_definitions(${TARGET}
          PRIVATE
             "_F2008")
    endif()
    # Linking for OpenMP host
    target_link_libraries(${TARGET}
       INTERFACE
        	 OpenMP::OpenMP_Fortran)
endforeach(TARGET)

install(
    TARGETS ${testTargets}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

=== debian/changelog ===
devicexlib (0.8.6-2) unstable; urgency=medium

  * Team upload.
  [ Adrian Bunk ]
  * libdevicexlib-dev: Drop Multi-Arch: same. Closes: #1103731.
  [ Santiago Vila ]
  * Fix clean target. Closes: #1044973.

 -- Santiago Vila <sanvila@debian.org>  Fri, 23 May 2025 21:55:00 +0200

devicexlib (0.8.6-1) unstable; urgency=medium

  * New upstream release.
  * debian/watch: Updated. 
  * debian/patches/fix_ppc64le_configure.patch: Refreshed.

 -- Michael Banck <mbanck@debian.org>  Sun, 06 Apr 2025 10:04:12 +0200

=== debian/control ===
Source: devicexlib
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: architecture-is-64-bit,
               debhelper (>> 12~),
               gfortran,
               libblas-dev,
               liblapack-dev
Standards-Version: 4.4.1
Homepage: https://gitlab.com/max-centre/components/devicexlib
Vcs-Browser: https://salsa.debian.org/debichem-team/devicexlib
Vcs-Git: https://salsa.debian.org/debichem-team/devicexlib.git

Package: libdevicexlib-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Library wrapping device-oriented routines and utilities
 The deviceXlib library wraps device-oriented routines and utilities.
 .
 This package contains the static library.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

include /usr/share/dpkg/buildflags.mk
LDFLAGS += -Wl,--as-needed
CFLAGS += $(LDFLAGS)
DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- all

override_dh_auto_install:
	mkdir -p $(CURDIR)/debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}
	mkdir -p $(CURDIR)/debian/tmp/usr/include
	install $(CURDIR)/src/libdevXlib.a $(CURDIR)/debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}
	install $(CURDIR)/src/*.mod $(CURDIR)/debian/tmp/usr/include

override_dh_auto_test:
	dh_auto_test
	(cd bin; for TEST in test*; do ./$$TEST; if [ "$$?" != 0 ]; then exit 1; fi; done)

=== debian/watch ===
version=4
opts="searchmode=plain" \
 https://gitlab.com/max-centre/components/@PACKAGE@/tags?sort=updated_desc -/archive/v?\d[\d.]+/@PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@
